unit ExportFunc;

interface

uses WisdomCoreInterfaceForD, ServicesInterface, Forms, ComCtrls, Graphics;

    function  DLLGetObject(const serviceID: PAnsiChar): IInterface; stdcall;
    procedure DLLGetPluginInfo(const im: IPluginInfo); stdcall;
    procedure DLLInitializePlugin(const IServiceMgr: IServiceManager); stdcall;
    procedure DLLUninitializePlugin(const IServiceMgr: IServiceManager); stdcall;
    procedure DLLServiceStart(const serviceID: PAnsiChar); stdcall;
    procedure DLLServiceStop(const serviceID: PAnsiChar); stdcall;

exports
   DLLGetObject,
   DLLGetPluginInfo,
   DLLInitializePlugin,
   DLLUninitializePlugin,
   DLLServiceStart,
   DLLServiceStop;

implementation

uses MyToolbarUI;

//DLLGetPluginInfoδʹSetServiceClass÷ӿڵʵܻ࣬
//ӵserviceIDķʱô˺ڴ˺д÷ӿڷؿܡ
//˺ҪΪC++ʵֵDLLģ飬ΪVCʵֵĽӿ޷ṩDelphiõʵTClassxxx
function DLLGetObject(const serviceID: PAnsiChar): IInterface; stdcall;
begin
  Result := nil;
end;

//úڿܻȡϢʱãܴimӿڣͨýӿڷϢͽӿڷϢ
procedure DLLGetPluginInfo(const im: IPluginInfo); stdcall;
begin
  im.SetAuthor('IceAir'); //ģ
  im.SetComment('ʾչʹãʾʹһԶ̬رչչֺ͹ܡ');//Ҫ˵
  im.SetPluginID('{BE855F6C-CE5D-42FF-85C2-CCC31AC7A47E}');//ID
  im.SetPluginName('ToolBarExtPoint');//
  im.SetVersion('1.0.0');//汾
  im.SetUpdateHistory('Ver1.0.0 20140621');//ʷ

  with im.AppendServiceInfo(IID_ToolBarExt) do begin
    SetAuthor('IceAir'); //ӿ
    SetComment('ToolBarԤĿɶ̬Ӱťչ㡣');//صҪ˵
    SetIsExtendPoint(True);
    SetSingleton(False);//ǷҪԵģʽ
    SetServiceName('IToolBarExt');//
  end;
end;

{˴һЩģҪĳʼúõ
ʱǣDLLѱ룬δ(еķ)}
procedure DLLInitializePlugin(const IServiceMgr: IServiceManager); stdcall;
begin
  GServiceManager := IServiceMgr;
  if IServiceMgr.ServiceIsActive(IID_AppInfo) then
    with IServiceMgr.GetService(IID_AppInfo) as IAppInfo do begin
      //ľͬһ»D7Exe + XE5DLL
      {Form1 := TForm1.Create(nil);
      //¾Ҳɣ
      //Form1 := TForm1.CreateParented(GetMainForm.Handle);
      Form1.Parent := GetMainForm;
      Form1.Show;}

      //¾칹ĽVCEXE + XE5DLL
      Form1 := TForm1.CreateParented(GetMainFormHandle);
      Form1.ParentWindow := GetMainFormHandle;
      Form1.Left := 0;
      Form1.Top  := 0;
      Form1.Visible := true;
      Form1.Show;
    end;
end;

//˴һЩģ˳ǰúܵõ
//ʱǣṩнӿڷͣãģ鼴DeActive
procedure DLLUninitializePlugin(const IServiceMgr: IServiceManager); stdcall;
begin
  if Assigned(Form1) then
    Form1.Free;
  GServiceManager := nil;  
end;

//񱻼
procedure DLLServiceStart(const serviceID: PAnsiChar); stdcall;
var
  t: TToolButton;
  bmp, bmp1: TBitmap;
begin
  //serviceǷʵֵǱչ
  if Assigned(Form1) and GServiceManager.ServiceIsActive(serviceID) then
    with GServiceManager.GetServiceInfo(serviceID) do
      if GetImplementServiceID = IID_ToolBarExt then begin
        //ǣToolBarӰť
        t := TToolButton.Create(Form1.ToolBar1);
        t.Parent := Form1.ToolBar1;
        t.Left := 1000;
        with GServiceManager.GetService(serviceID) as IExtToolButton do begin
          t.Caption := string(GetCaption);
          bmp := tbitmap.Create;
          bmp.Width := 48;
          bmp.Height := 48;
          GetBitmap(bmp.Canvas.Handle);
          t.ImageIndex := Form1.ImageList1.AddMasked(bmp, bmp.Canvas.Pixels[0,0]);
          t.OnClick := GetClickEvent;
        end;
      end;
end;

//DeActiveǰ
procedure DLLServiceStop(const serviceID: PAnsiChar); stdcall;
begin

end;

end.
