unit ExportFunc;

interface

uses WisdomCoreInterfaceForD, ServicesInterface, ServicesImplement;

    function  DLLGetObject(const serviceID: PAnsiChar): IInterface; stdcall;
    procedure DLLGetPluginInfo(const im: IPluginInfo); stdcall;
    procedure DLLInitializePlugin(const IServiceMgr: IServiceManager); stdcall;
    procedure DLLUninitializePlugin(const IServiceMgr: IServiceManager); stdcall;
    procedure DLLServiceStart(const serviceID: PAnsiChar); stdcall;
    procedure DLLServiceStop(const serviceID: PAnsiChar); stdcall;

exports
   DLLGetObject,
   DLLGetPluginInfo,
   DLLInitializePlugin,
   DLLUninitializePlugin,
   DLLServiceStart,
   DLLServiceStop;


implementation

uses SplashForm;

//DLLGetPluginInfoδʹSetServiceClass÷ӿڵʵܻ࣬
//ӵserviceIDķʱô˺ڴ˺д÷ӿڷؿܡ
//˺ҪΪC++ʵֵDLLģ飬ΪVCʵֵĽӿ޷ṩDelphiõʵTClassxxx
function DLLGetObject(const serviceID: PAnsiChar): IInterface; stdcall;
begin
  Result := nil;
end;

//úڿܻȡϢʱãܴimӿڣͨýӿڷϢͽӿڷϢ
procedure DLLGetPluginInfo(const im: IPluginInfo); stdcall;
begin
  im.SetAuthor(''); //ģ
  im.SetComment('');//Ҫ˵
  im.SetPluginID('{86321E0F-9A55-426C-843F-A55036086617}');//ID
  im.SetPluginName('SplashDemo');//
  im.SetVersion('1.0.0');//汾
  im.SetUpdateHistory('');//ʷ

  //Զһչ㣬ֻػع̵ϢͨչϢͳȥ
  //κʵչFormܳΪһԸƾˡ
  {
  with im.AppendServiceInfo(IID_SplashExtPoint) do begin
    SetAuthor(''); //ӿ
    SetComment('');//صҪ˵
    SetSingleton(True);//ǷҪԵģʽ
    SetServiceClass(TSplashExtPoint);//ӿڵʵ
    SetServiceName('ISplashExtPoint');//
    SetImplementServiceID('');//ʵֵչID
  end; }
end;

{˴һЩģҪĳʼúõ
ʱǣDLLѱ룬δ(еķ)}
procedure DLLInitializePlugin(const IServiceMgr: IServiceManager); stdcall;
begin
  GServiceManager := IServiceMgr;
  frmSplash := TfrmSplash.Create(nil);
  frmSplash.Show;
end;

//˴һЩģ˳ǰúܵõ
//ʱǣṩнӿڷͣãģ鼴DeActive
procedure DLLUninitializePlugin(const IServiceMgr: IServiceManager); stdcall;
begin
  frmSplash.Free;
  GServiceManager := nil;
end;

//񱻼
procedure DLLServiceStart(const serviceID: PAnsiChar); stdcall;
begin
  //Ϊڵļʾ룬οвô˴룬
  //ʾFormģʾ
  if serviceID = IID_SplashExtPoint then begin
    frmSplash.Tag := 1; //ĲDLLǵһصġ
    Exit;
  end;

  with GServiceManager.GetService(PLUGIN_MANAGER_ID) as IPluginManager do begin
    if GetPluginsCount<=frmSplash.Tag then
      Exit;
    with GetPluginInfoByIndex(GetPluginsCount-1) as IPluginInfo do begin
      frmSplash.mmo1.Lines.Append(
        'ز' + GetPluginName + '  汾' + GetVersion + '  ļ' + GetDllName);
    end;
    frmSplash.Tag := GetPluginsCount;
  end;
end;

//DeActiveǰ
procedure DLLServiceStop(const serviceID: PAnsiChar); stdcall;
begin
end;

end.
