{*******************************************************}
{                                                       }
{       WisdomPluginFramework                           }
{       2014 IceAir                                     }
{       ice.air@126.com  QQ: 3216343                    }
{                                                       }
{*******************************************************}

//////////////////////////////////////////////////////////////////
//                        ʹ˵                              //
//   ɸơַʹáչܴ룬Ԫ   //
//   ߴкõ޸ģ뷴ߣԱ   //
//   ΪṩƾĿܡ                         //
//                                                              //
//   Wisdomʵܺϼ֮ҫǻ֮â   //
//                                                              //
//////////////////////////////////////////////////////////////////

{--------------------------------------------------------
                           ;
      WisdomPluginFrameworkںOSGI΢ں + Eclipse
  չƵܣDelphiʵ֣
  ʹDelphiBCBVC++УṩǳǿĲ
  ܲʽ̵Ȥ
 --------------------------------------------------------
  ¼¼ 
 --------------------------------------------------------
 2014.8.1 ver 1.6
   ˰汾֧D7 ~ XE6汾ExeDllȫýܹҪ£
 1ʹõַѡΪ_FORCE_ANSI/_FORCE_UNICODE/_USE_WSTRING࣬
    Ĭʹ_USE_WSTRINGD7~XE6UPDLL֧֣ȷֻʹ
    UnicodeDLLD2009ʱʹ_FORCE_UNICODED7_FORCE_ANSI
 2C++ͷļҲӱԸʹchar*wchar_t*
 3Ӷbpl֧
 4ԲͬDelphi汾룬֧D7~XE6UP˳ƽ̨
 5Splash Demoʾ漰ع
 6BPL DemoʾBPL + DLLĻϹģʽ
 7MemoryLoader DemoһڴDLLʾذһҪ
 8ĿļܿԱΪDllBCBVCʹ
 9VC++ʹÿܽвʾ
 --------------------------------------------------------
 2014.07.20 ver 1.5
   DelphiϹٷ
 1. ٵ˺ƣϸ鲢ƺĴ߼
 2ɲPluginConfigԶԲxml
 3ӶVC++Ĳֵ֧Ԫ
 4DemoExtendPointCPlus
 --------------------------------------------------------
 2012.07.xx ver 0.5
 1. 壬Ȼæʱѷһߡ
}

unit WisdomFramework;

{$INCLUDE Def.inc}

interface

uses
  {$IFDEF IDE_XE4up}
  Winapi.Windows, System.SysUtils, System.Classes, System.StrUtils, System.IniFiles,
  {$ELSE}
  Windows, SysUtils, Classes, StrUtils, IniFiles,
  {$ENDIF}
  ResultCode, XmlConfig,
  {$IFDEF _USE_FOR_CPP}
  WisdomCoreInterfaceForC,
  {$ENDIF}
  WisdomCoreInterfaceForD;

{$INCLUDE MyString.inc}

type
  TWisdomFramework = class(TObject)
  public
    class procedure FinalFramwork;
    class procedure InitFramwork;
    class procedure Run;
    class procedure Stop;
  end;

  {$IFDEF _USE_FOR_CPP}
    {$INCLUDE ClassDefineForC.inc}
  {$ELSE}
  TServiceInfo = class(TPluginInterfacedObject, IServiceInfo)
  protected
    FAuthor: MyString;
    FBelongToPlugin: ^IPluginInfo;
    FComment: MyString;
    FCreateObjFunc: TCreateObjectFunc;
    FExtServiceList: THashedStringList;
    FImpServiceID: MyString;
    FIsActive: Boolean;
    FIsExtendPoint: Boolean;
    FIsSingleton: Boolean;
    FReadOnly: Boolean;
    FServiceClass: TPluginClass;
    FServiceIntf: IInterface;
    FServiceName: MyString;
    Fsid: MyString;
    FVersion: MyString;
  public
    constructor Create; override;
    destructor Destroy; override;
    procedure AddExtendPointImpService(const service: IServiceInfo); virtual;
    function GetAuthor: MyString; virtual;
    function GetBelongToPlugin: IPluginInfo; virtual;
    function GetComment: MyString; virtual;
    function GetCreateObjectFunc: TCreateObjectFunc; virtual;
    function GetExtendPointImpService(idx: Integer): IServiceInfo; virtual;
    function GetExtendPointImpServiceCount: Integer; virtual;
    function GetImplementServiceID: MyString; virtual;
    function GetSelfObject: TObject; virtual;
    function GetServiceClass: TPluginClass; virtual;
    function GetServiceID: MyString; virtual;
    function GetServiceIntf: IInterface; virtual;
    function GetServiceName: MyString; virtual;
    function GetVersion: MyString; virtual;
    function IsActive: Boolean; virtual;
    function IsExtendPoint: Boolean; virtual;
    function IsSingleton: Boolean; virtual;
    procedure RemoveExtendPointImpService(const sid: MyString); virtual;
    procedure SetActive(act: Boolean); virtual;
    procedure SetAuthor(const author: MyString); virtual;
    procedure SetBelongToPlugin(const ipf: IPluginInfo); virtual;
    procedure SetComment(const comment: MyString); virtual;
    procedure SetCreateObjectFunc(const func: TCreateObjectFunc); virtual;
    procedure SetImplementServiceID(const impID: MyString); virtual;
    procedure SetIsExtendPoint(isExtPoint: Boolean); virtual;
    procedure SetReadOnly; virtual;
    procedure SetServiceClass(const intClass: TPluginClass); virtual;
    procedure SetServiceID(const id: MyString); virtual;
    procedure SetServiceIntf(const sv: IInterface); virtual;
    procedure SetServiceName(const sName: MyString); virtual;
    procedure SetSingleton(isSingleton: Boolean); virtual;
    procedure SetVersion(const ver: MyString); virtual;
  end;

  TPluginInfo = class(TPluginInterfacedObject, IPluginInfo)
  protected
    FActived: Boolean;
    FAuthor: MyString;
    FComment: MyString;
    FLoadedThroughConfig: Boolean;
    FPluginID: MyString;
    FPluginLoader: IPluginLoader;
    FPluginName: MyString;
    FReadOnly: Boolean;
    FServiceList: THashedStringList;
    FUpdateHistory: MyString;
    FVersion: MyString;
  public
    constructor Create; override;
    destructor Destroy; override;
    function AppendServiceInfo(const sid: MyString): IServiceInfo; virtual;
    function GetAuthor: MyString; virtual;
    function GetComment: MyString; virtual;
    function GetDllName: MyString; virtual;
    function GetPluginID: MyString; virtual;
    function GetPluginLoader: IPluginLoader; virtual;
    function GetPluginName: MyString; virtual;
    function GetSelfObject: TObject; virtual;
    function GetServiceCount: Integer; virtual;
    function GetServiceInfo(idx: Integer): IServiceInfo; virtual;
    function GetUpdateHistory: MyString; virtual;
    function GetVersion: MyString; virtual;
    function IsActive: Boolean; virtual;
    function IsLoadedThroughConfig: Boolean; virtual;
    procedure SetActive(act: Boolean); virtual;
    procedure SetAuthor(const author: MyString); virtual;
    procedure SetComment(const comment: MyString); virtual;
    procedure SetIsLoadedThroughConfig(ltFormCfg: Boolean); virtual;
    procedure SetPluginID(const id: MyString); virtual;
    procedure SetPluginLoader(const loader: IPluginLoader); virtual;
    procedure SetPluginName(const theName: MyString); virtual;
    procedure SetReadOnly; virtual;
    procedure SetUpdateHistory(const memo: MyString); virtual;
    procedure SetVersion(const ver: MyString); virtual;
  end;

  TPluginLoader = class(TPluginInterfacedObject, IPluginLoader)
  protected
    FDLLFile: MyString;
    FDllHandle: THandle;
  public
    constructor Create; override;
    destructor Destroy; override;
    function DLLGetObject(const serviceID: MyString): IInterface; virtual;
    function DLLGetPluginInfo(const im: IPluginInfo): Integer; virtual;
    procedure DLLInitializePlugin(const IServiceMgr: IServiceManager); virtual;
    procedure DLLServiceStart(const serviceID: MyString); virtual;
    procedure DLLServiceStop(const serviceID: MyString); virtual;
    procedure DLLUninitializePlugin(const IServiceMgr: IServiceManager); virtual;
    function GetLoadedPluginFile: MyString; virtual;
    function GetSelfObject: TObject; virtual;
    function LoadPlugin(const pluginFile: MyString): Integer; virtual;
    function UnLoadPlugin: Integer; virtual;
  end;

  TPluginManager = class(TPluginInterfacedObject, IPluginManager)
  protected
    FPluginList: THashedStringList;
  public
    constructor Create; override;
    destructor Destroy; override;
    function CfgLoadPluginByPluginID(const pluginID: MyString): Integer; virtual;
    function CfgLoadPluginByServiceID(const serviceID: MyString): Integer; virtual;
    function CfgReLoadPlugins: Integer; virtual;
    function GetPluginInfoByIndex(idx: Integer): IPluginInfo; virtual;
    function GetPluginInfoByPluginID(const pluginID: MyString): IPluginInfo; virtual;
    function GetPluginsCount: Integer; virtual;
    function GetSelfObject: TObject; virtual;
    function LoadPluginDirect(const pluginFile: MyString; const useLoader:
        MyString=''): Integer; virtual;
    function SetPluginActiveByIndex(idx: Integer): Integer; virtual;
    function SetPluginActiveByPluginID(const pluginID: MyString): Integer; virtual;
    function SetPluginDeActiveByIndex(idx: Integer): Integer; virtual;
    function SetPluginDeActiveByPluginID(const pluginID: MyString): Integer; virtual;
    function UnLoadPluginByIndex(idx: Integer): Integer; virtual;
    function UnLoadPluginByPluginID(const pluginID: MyString): Integer; virtual;
    function UpdatePluginDirect(const pluginFile: MyString; const useLoader:
        MyString=''): Integer; virtual;
  end;

  TServiceManager = class(TPluginInterfacedObject, IServiceManager)
  protected
    FServiceList: THashedStringList;
    function GetServiceIdx(const serviceID: MyString): Integer;
    function RegExtService(const sv: IServiceInfo): Integer;
  public
    constructor Create; override;
    destructor Destroy; override;
    function AddServiceQuick(const serviceID, impServiceID: MyString; const func:
        TCreateObjectFunc; active: Boolean = True; isSingleton: Boolean = False;
        isExtendPoint: Boolean = False): Boolean; overload; virtual;
    function AddServiceQuick(const serviceID, impServiceID: MyString; const
        serviceClass: TPluginClass=nil; active: Boolean=True; isSingleton:
        Boolean=False; isExtendPoint: Boolean=False): Boolean; overload; virtual;
    function Count: Integer; virtual;
    function ExistService(const serviceID: MyString): Boolean; virtual;
    function GetExtService(const serviceID: MyString; idx: Integer): IInterface; virtual;
    function GetExtServiceCount(const serviceID: MyString): Integer; virtual;
    function GetSelfObject: TObject; virtual;
    function GetService(const serviceID: MyString): IInterface; virtual;
    function GetServiceInfo(const serviceID: MyString): IServiceInfo; virtual;
    function RegService(const sv: IServiceInfo): Integer; virtual;
    function ServiceIsActive(const serviceID: MyString): Boolean; virtual;
    function StartService(const serviceID: MyString): Boolean; virtual;
    function StopService(const serviceID: MyString): Boolean; virtual;
    function UnRegService(const serviceID: MyString): Integer; virtual;
  end;

  {$ENDIF}

  function GetObjFromIntf(AClass: TClass; const Intf: IInterface): TObject;
var
  GServiceManagerObj: TServiceManager = nil;

implementation

{$IFDEF _USE_FOR_CPP}
  {$INCLUDE ClassImplementForC.inc}
{$ENDIF}

function GetObjFromIntf(AClass: TClass; const Intf: IInterface): TObject;
var
  PIntfTable: PInterfaceTable;
  IntfEntry: TInterfaceEntry;
  i: Integer;
begin
  Result := nil;
  //ȡýӿڱṹ
  PIntfTable := AClass.GetInterfaceTable;
  if PIntfTable = nil then
    Exit;
  while AClass <> nil do
  begin
    for i := 0 to PIntfTable^.EntryCount - 1 do
    begin
      IntfEntry := PIntfTable^.Entries[i];
      //жϽӿڱָĵַǷʹӿָĵַͬ
      if PPointer(Intf)^ = IntfEntry.VTable then
      begin
        //ƫƵ׵ַ
        Result := TObject(Integer(Pointer(Intf)) - IntfEntry.IOffset);
        Exit;
      end;
    end;
    //ڸ
    AClass := AClass.ClassParent;
  end;
end;

{ TServiceInfo }

{
********************************* TServiceInfo *********************************
}
constructor TServiceInfo.Create;
begin
  inherited;
  FAuthor := '';
  FComment := '';
  FImpServiceID := '';
  FIsExtendPoint := False;
  FIsActive := False;
  FIsSingleton := False;
  FServiceClass := nil;
  FServiceName := '';
  FServiceIntf := nil;
  Fsid := '';
  FVersion := '';
  FBelongToPlugin := nil;
  FReadOnly := False;
  FCreateObjFunc := nil;

  FExtServiceList := THashedStringList.Create;
end;

destructor TServiceInfo.Destroy;
var
  i: Integer;
begin
  FServiceIntf := nil;
  FBelongToPlugin := nil;

  //յ㣬ǵUnRegsviceͷչʵõãбоͿܻ
  //IServiceInfoӿڵãͷ
  for i:=FExtServiceList.Count-1 downto 0 do
    IServiceInfo(Pointer(FExtServiceList.Objects[i]))._Release;
  FExtServiceList.Free;
  inherited;
end;

procedure TServiceInfo.AddExtendPointImpService(const service: IServiceInfo);
begin
  if Assigned(service) then
  begin
    if FExtServiceList.IndexOf(service.GetServiceID) > -1 then
      Exit;
    if service.IsExtendPoint
      and service.IsSingleton
        and (service.GetExtendPointImpServiceCount>0) then begin
          IServiceInfo(Pointer(FExtServiceList.Objects[0]))._Release;
          FExtServiceList.Delete(0);
        end;
    service._AddRef;
    FExtServiceList.AddObject(service.GetServiceID, Pointer(service));
  end;
end;

function TServiceInfo.GetAuthor: MyString;
begin
  Result := FAuthor;
end;

function TServiceInfo.GetBelongToPlugin: IPluginInfo;
begin
  Result := IPluginInfo(FBelongToPlugin);
end;

function TServiceInfo.GetComment: MyString;
begin
  Result := FComment;
end;

function TServiceInfo.GetCreateObjectFunc: TCreateObjectFunc;
begin
  Result := FCreateObjFunc;
end;

function TServiceInfo.GetExtendPointImpService(idx: Integer): IServiceInfo;
begin
  Result := nil;
  if (idx < 0) or (idx >= FExtServiceList.Count) then
    Exit;
  Result := IServiceInfo(Pointer(FExtServiceList.Objects[idx]));
end;

function TServiceInfo.GetExtendPointImpServiceCount: Integer;
begin
  Result := FExtServiceList.Count;
end;

function TServiceInfo.GetImplementServiceID: MyString;
begin
  Result := FImpServiceID;
end;

function TServiceInfo.GetSelfObject: TObject;
begin
  Result := Self;
end;

function TServiceInfo.GetServiceClass: TPluginClass;
begin
  Result := FServiceClass;
end;

function TServiceInfo.GetServiceID: MyString;
begin
  Result := Fsid;
end;

function TServiceInfo.GetServiceIntf: IInterface;
begin
  Result := FServiceIntf;
end;

function TServiceInfo.GetServiceName: MyString;
begin
  Result := FServiceName
end;

function TServiceInfo.GetVersion: MyString;
begin
  Result := FVersion;
end;

function TServiceInfo.IsActive: Boolean;
begin
  Result := FIsActive;
end;

function TServiceInfo.IsExtendPoint: Boolean;
begin
  Result := FIsExtendPoint;
end;

function TServiceInfo.IsSingleton: Boolean;
begin
  Result := FIsSingleton;
end;

procedure TServiceInfo.RemoveExtendPointImpService(const sid: MyString);
var
  idx: Integer;
begin
  idx := FExtServiceList.IndexOf(sid);
  if idx = -1 then
    Exit;
  //̰߳ȫ
  IServiceInfo(Pointer(FExtServiceList.Objects[idx]))._Release;
  FExtServiceList.Delete(idx);
end;

procedure TServiceInfo.SetActive(act: Boolean);
begin
  FIsActive := act;
end;

procedure TServiceInfo.SetAuthor(const author: MyString);
begin
  if not FReadOnly then
    FAuthor := author;
end;

procedure TServiceInfo.SetBelongToPlugin(const ipf: IPluginInfo);
begin
  if not FReadOnly then
    FBelongToPlugin := Pointer(ipf);
end;

procedure TServiceInfo.SetComment(const comment: MyString);
begin
  if not FReadOnly then
    FComment := comment;
end;

procedure TServiceInfo.SetCreateObjectFunc(const func: TCreateObjectFunc);
begin
  FCreateObjFunc := func;
end;

procedure TServiceInfo.SetImplementServiceID(const impID: MyString);
begin
  if not FReadOnly then
    FImpServiceID := impID;
end;

procedure TServiceInfo.SetIsExtendPoint(isExtPoint: Boolean);
begin
  if not FReadOnly then
    FIsExtendPoint := isExtPoint;
end;

procedure TServiceInfo.SetReadOnly;
begin
  FReadOnly := True;
end;

procedure TServiceInfo.SetServiceClass(const intClass: TPluginClass);
begin
  if not FReadOnly then
    FServiceClass := intClass;
end;

procedure TServiceInfo.SetServiceID(const id: MyString);
begin
  if not FReadOnly then
    Fsid := id;
end;

procedure TServiceInfo.SetServiceIntf(const sv: IInterface);
begin
  FServiceIntf := sv;
end;

procedure TServiceInfo.SetServiceName(const sName: MyString);
begin
  if not FReadOnly then
    FServiceName := sName;
end;

procedure TServiceInfo.SetSingleton(isSingleton: Boolean);
begin
  if not FReadOnly then
    FIsSingleton := isSingleton;
end;

procedure TServiceInfo.SetVersion(const ver: MyString);
begin
  if not FReadOnly then
    FVersion := ver;
end;

{ TPluginInfo }

{
********************************* TPluginInfo **********************************
}
constructor TPluginInfo.Create;
begin
  inherited;
  FAuthor := '';
  FComment := '';
  FPluginID := '';
  FPluginName := '';
  FUpdateHistory := '';
  FVersion := '';
  FActived := false;
  FLoadedThroughConfig := False;
  FReadOnly := False;
  if GServiceManagerObj.ServiceIsActive(PLUGIN_LOADER) then
    FPluginLoader := GServiceManagerObj.GetService(PLUGIN_LOADER) as IPluginLoader
  else
    FPluginLoader := TPluginLoader.Create;
  FServiceList := THashedStringList.Create;
end;

destructor TPluginInfo.Destroy;
var
  i: Integer;
  //sv: IServiceInfo;
begin
{  for i := FServiceList.Count - 1 downto 0 do begin
    sv := IServiceInfo(Pointer(FServiceList.Objects[i]));
    sv._Release;
    sv := nil;
  end;
}
  for i := FServiceList.Count - 1 downto 0 do
    IServiceInfo(Pointer(FServiceList.Objects[i]))._Release;
  FServiceList.Free;
  FPluginLoader := nil;
  inherited;
end;

function TPluginInfo.AppendServiceInfo(const sid: MyString): IServiceInfo;
var
  i: Integer;
begin
  //idѴڣɾԭģǡ
  i := FServiceList.IndexOf(sid);
  if i > -1 then
  begin
    Result := IServiceInfo(Pointer(FServiceList.Objects[i]));
    Result._Release;
    Result := nil;
    FServiceList.Delete(i);
  end;

  Result := TServiceInfo.Create;
  Result.SetServiceID(sid);
  Result.SetBelongToPlugin(Self);
  Result._AddRef;
  FServiceList.AddObject(sid, Pointer(Result));
end;

function TPluginInfo.GetAuthor: MyString;
begin
  Result := FAuthor;
end;

function TPluginInfo.GetComment: MyString;
begin
  Result := FComment;
end;

function TPluginInfo.GetDllName: MyString;
begin
  Result := FPluginLoader.GetLoadedPluginFile;
end;

function TPluginInfo.GetPluginID: MyString;
begin
  Result := FPluginID;
end;

function TPluginInfo.GetPluginLoader: IPluginLoader;
begin
  Result := FPluginLoader;
end;

function TPluginInfo.GetPluginName: MyString;
begin
  Result := FPluginName;
end;

function TPluginInfo.GetSelfObject: TObject;
begin
  Result := Self;
end;

function TPluginInfo.GetServiceCount: Integer;
begin
  Result := FServiceList.Count;
end;

function TPluginInfo.GetServiceInfo(idx: Integer): IServiceInfo;
begin
  if (idx > -1) and (idx < FServiceList.Count) then
    Result := IServiceInfo(Pointer(FServiceList.Objects[idx]))
  else
    Result := nil;
end;

function TPluginInfo.GetUpdateHistory: MyString;
begin
  Result := FUpdateHistory;
end;

function TPluginInfo.GetVersion: MyString;
begin
  Result := FVersion;
end;

function TPluginInfo.IsActive: Boolean;
begin
  Result := FActived;
end;

function TPluginInfo.IsLoadedThroughConfig: Boolean;
begin
  Result := FLoadedThroughConfig;
end;

procedure TPluginInfo.SetActive(act: Boolean);
begin
  FActived := act;
end;

procedure TPluginInfo.SetAuthor(const author: MyString);
begin
  if not FReadOnly then
    FAuthor := author;
end;

procedure TPluginInfo.SetComment(const comment: MyString);
begin
  if not FReadOnly then
    FComment := comment;
end;

procedure TPluginInfo.SetIsLoadedThroughConfig(ltFormCfg: Boolean);
begin
  FLoadedThroughConfig := ltFormCfg;
end;

procedure TPluginInfo.SetPluginID(const id: MyString);
begin
  if not FReadOnly then
    FPluginID := id;
end;

procedure TPluginInfo.SetPluginLoader(const loader: IPluginLoader);
begin
  FPluginLoader := nil;
  FPluginLoader := loader;
end;

procedure TPluginInfo.SetPluginName(const theName: MyString);
begin
  if not FReadOnly then
    FPluginName := theName;
end;

procedure TPluginInfo.SetReadOnly;
begin
  FReadOnly := True;
end;

procedure TPluginInfo.SetUpdateHistory(const memo: MyString);
begin
  if not FReadOnly then
    FUpdateHistory := memo;
end;

procedure TPluginInfo.SetVersion(const ver: MyString);
begin
  if not FReadOnly then
    FVersion := ver;
end;

{ TServiceManager }

{
******************************* TServiceManager ********************************
}
constructor TServiceManager.Create;
var
  sv: TServiceInfo;
begin
  inherited;
  ObjFree := True;
  FServiceList := THashedStringList.Create;

  //öȡΪӵб
  sv := TServiceInfo.Create;
  sv.SetServiceID(CONFIG_ID);
  sv.SetServiceClass(TXmlConfig);
  sv.SetServiceName('IConfig');
  sv.SetSingleton(true);
  sv.SetVersion(VER);
  sv.SetActive(True);
  sv.SetReadOnly;
  RegService(sv);

  //ҲǷ񣬿Զ̬滻ʵLinux¼ؿļ
  sv := TServiceInfo.Create;
  sv.SetServiceID(PLUGIN_LOADER);
  sv.SetServiceClass(TPluginLoader);
  sv.SetServiceName('IPluginLoader');
  sv.SetVersion(VER);
  sv.SetActive(True);
  sv.SetReadOnly;
  RegService(sv);

  //ҲΪӵб
  sv := TServiceInfo.Create;
  sv.SetServiceID(PLUGIN_MANAGER_ID);
  sv.SetServiceClass(TPluginManager);
  sv.SetServiceName('IPluginManager');
  sv.SetSingleton(true);
  sv.SetVersion(VER);
  sv.SetActive(True);
  sv.SetReadOnly;
  RegService(sv);

  //ѷϢҲӵбУҪֶ̬ûʹ
  sv := TServiceInfo.Create;
  sv.SetServiceID(SERVICE_INFO_ID);
  sv.SetServiceClass(TServiceInfo);
  sv.SetServiceName('IServiceInfo');
  sv.SetVersion(VER);
  sv.SetActive(True);
  sv.SetReadOnly;
  RegService(sv);

  sv := TServiceInfo.Create;
  sv.SetServiceID(PLUGIN_INFO_ID);
  sv.SetServiceClass(TPluginInfo);
  sv.SetServiceName('IPluginInfo');
  sv.SetVersion(VER);
  sv.SetActive(True);
  sv.SetReadOnly;
  RegService(sv);
end;

destructor TServiceManager.Destroy;
var
  idx: Integer;
  sv: IServiceInfo;
  pm: IPluginManager;
begin
  //ٲϢ
  if ServiceIsActive(PLUGIN_INFO_ID) then
    UnRegService(PLUGIN_INFO_ID);
  //ٷϢ
  if ServiceIsActive(SERVICE_INFO_ID) then
    UnRegService(SERVICE_INFO_ID);
  //ټ
  if ServiceIsActive(PLUGIN_LOADER) then
    UnRegService(PLUGIN_LOADER);
  //
  if ServiceIsActive(CONFIG_ID) then
    UnRegService(CONFIG_ID);
  //ٲ
  if ServiceIsActive(PLUGIN_MANAGER_ID) then begin
    pm := GetService(PLUGIN_MANAGER_ID) as IPluginManager;
    for idx:=pm.GetPluginsCount-1 downto 0 do
      pm.UnLoadPluginByIndex(idx);
    pm := nil;
    UnRegService(PLUGIN_MANAGER_ID);
  end;

  for idx:=FServiceList.Count-1 downto 0 do begin
    sv := IServiceInfo(Pointer(FServiceList.Objects[idx]));
    sv._Release;
    sv := nil;
  end;
  FServiceList.Free;
  inherited;
end;

function TServiceManager.AddServiceQuick(const serviceID, impServiceID: MyString;
    const func: TCreateObjectFunc; active: Boolean = True; isSingleton: Boolean
    = False; isExtendPoint: Boolean = False): Boolean;
var
  sv: IServiceInfo;
begin
  sv := TServiceInfo.Create;
  sv.SetServiceID(serviceID);
  sv.SetImplementServiceID(impServiceID);
  sv.SetCreateObjectFunc(func);
  sv.SetIsExtendPoint(isExtendPoint);
  sv.SetSingleton(isSingleton);  //ExtendPointģʽ£赥Ϊչֻֻһʵ
  sv.SetActive(active);
  Result := RegService(sv) = ERROR_SUCCESS;
end;

function TServiceManager.AddServiceQuick(const serviceID, impServiceID: MyString;
    const serviceClass: TPluginClass=nil; active: Boolean=True; isSingleton:
    Boolean=False; isExtendPoint: Boolean=False): Boolean;
var
  sv: IServiceInfo;
begin
  sv := TServiceInfo.Create;
  sv.SetServiceID(serviceID);
  sv.SetImplementServiceID(impServiceID);
  sv.SetServiceClass(serviceClass);
  sv.SetIsExtendPoint(isExtendPoint);
  sv.SetSingleton(isSingleton);  //ExtendPointģʽ£赥Ϊչֻֻһʵ
  sv.SetActive(active);
  Result := RegService(sv) = ERROR_SUCCESS;
end;

function TServiceManager.Count: Integer;
begin
  Result := FServiceList.Count;
end;

function TServiceManager.ExistService(const serviceID: MyString): Boolean;
begin
  Result := FServiceList.IndexOf(serviceID) > -1;
end;

function TServiceManager.GetExtService(const serviceID: MyString; idx: Integer):
    IInterface;
var
  i, j, k: Integer;
  sv: IServiceInfo;
begin
  Result := nil;
  i := GetServiceIdx(serviceID);
  j := GetExtServiceCount(serviceID);
  if (i>-1) and (j=0) then
    if ServiceIsActive(CONFIG_ID) and ServiceIsActive(PLUGIN_MANAGER_ID) then
      with GetService(CONFIG_ID) as IConfig, GetService(PLUGIN_MANAGER_ID) as IPluginManager do begin
        j := GetExtImpServiceCount(serviceID);
        if j>0 then
          for k:=0 to j-1 do begin
            CfgLoadPluginByServiceID(GetExtImpServiceID(serviceID, k));
          end;
      end;


  if (idx < 0) or (idx>=GetExtServiceCount(serviceID)) then
    Exit;
  sv := IServiceInfo(Pointer(FServiceList.Objects[i]));
  if sv.IsActive then begin
    if sv.IsExtendPoint then begin
      if sv.IsSingleton then
        idx := 0;
      sv := sv.GetExtendPointImpService(idx);
      Result := GetService(sv.GetServiceID);
    end else
      Result := GetService(serviceID);
  end;
end;

function TServiceManager.GetExtServiceCount(const serviceID: MyString): Integer;
var
  sv: IServiceInfo;
begin
  Result := GetServiceIdx(serviceID);
  if Result = -1 then
    Result := 0
  else begin
    sv := IServiceInfo(Pointer(FServiceList.Objects[Result]));
    Result := sv.GetExtendPointImpServiceCount;
  end;
end;

function TServiceManager.GetSelfObject: TObject;
begin
  Result := Self;
end;

function TServiceManager.GetService(const serviceID: MyString): IInterface;
  function GetServiceIdx: Integer;
  begin
    Result := FServiceList.IndexOf(serviceID);
    if Result = -1 then
    begin
      //ûҵ񣬿ûмأԼһ£ټһΡ
      if ServiceIsActive(PLUGIN_MANAGER_ID) then
        with GetService(PLUGIN_MANAGER_ID) as IPluginManager do
          CfgLoadPluginByServiceID(serviceID);
      Result := FServiceList.IndexOf(serviceID);
    end;
  end;
var
  idx: Integer;
  sv: IServiceInfo;
begin
  Result := nil;
  idx := GetServiceIdx;
  if idx = -1 then
    Exit;

  sv := IServiceInfo(Pointer(FServiceList.Objects[idx]));
  //ͣ״̬NULL
  if not sv.IsActive then
    Exit;
  if sv.IsExtendPoint then begin
    GetExtService(serviceID, 0);
    Exit;
  end;

  //ǷǵIsSingletonǣIService.ServiceObjǷΪգ
  if sv.IsSingleton then begin
    if sv.GetServiceIntf = nil then
      if sv.GetServiceClass <> nil then
        //DelphiĲУʹDLLGetObject
        sv.SetServiceIntf(TPluginInterfacedObject(sv.GetServiceClass.NewInstance).Create)
      else if Assigned(sv.GetCreateObjectFunc) then
        sv.SetServiceIntf(sv.GetCreateObjectFunc()(GServiceManagerObj, sv))
      else if Assigned(sv.GetBelongToPlugin) then
        sv.SetServiceIntf(sv.GetBelongToPlugin.GetPluginLoader.DLLGetObject(serviceID));

    Result := sv.GetServiceIntf;
  end else begin
    if sv.GetServiceClass <> nil then
      //DelphiĲУʹDLLGetObject
      Result := TPluginInterfacedObject(sv.GetServiceClass.NewInstance).Create
    else if Assigned(sv.GetCreateObjectFunc) then
      Result := sv.GetCreateObjectFunc()(GServiceManagerObj, sv)
    else if Assigned(sv.GetBelongToPlugin) then
      Result := sv.GetBelongToPlugin.GetPluginLoader.DLLGetObject(serviceID);
  end;
end;

function TServiceManager.GetServiceIdx(const serviceID: MyString): Integer;
begin
  Result := FServiceList.IndexOf(serviceID);
  if Result = -1 then
  begin
    //ûҵ񣬿ûмأԼһ£ټһΡ
    if ServiceIsActive(PLUGIN_MANAGER_ID) then
      with GetService(PLUGIN_MANAGER_ID) as IPluginManager do
        CfgLoadPluginByServiceID(serviceID);
    Result := FServiceList.IndexOf(serviceID);
  end;
end;

function TServiceManager.GetServiceInfo(const serviceID: MyString): IServiceInfo;
var
  idx: Integer;
begin
  idx := GetServiceIdx(serviceID);
  if idx > -1 then
    Result := IServiceInfo(Pointer(FServiceList.Objects[idx]))
  else
    Result := nil;
end;

function TServiceManager.RegExtService(const sv: IServiceInfo): Integer;
var
  i: Integer;
  temSV: IServiceInfo;
begin
  //úֻRegServiceڲã˲ټЩ
{  if not Assigned(sv) then begin
    Result := ERROR_INTERFACE_IS_NULL;
    Exit;
  end;

  Result := FServiceList.IndexOf(sv.GetServiceID);
  if Result > -1 then begin
    Result := ERROR_SERVICE_EXIST;
    Exit;
  end;
  }

  sv._AddRef;
  FServiceList.AddObject(sv.GetServiceID, Pointer(sv));
  //Ѱҷбʵָ÷ӿڵչ
  for i := FServiceList.Count - 1 downto 0 do begin
    temSV := IServiceInfo(Pointer(FServiceList.Objects[i]));
    if temSV.GetImplementServiceID = sv.GetServiceID then
      sv.AddExtendPointImpService(temSV);
  end;
  Result := ERROR_SUCCESS;
end;

function TServiceManager.RegService(const sv: IServiceInfo): Integer;
begin
  if not Assigned(sv) then begin
    Result := ERROR_INTERFACE_IS_NULL;
    Exit;
  end;

  Result := FServiceList.IndexOf(sv.GetServiceID);
  if Result > -1 then begin
    Result := ERROR_SERVICE_EXIST;
    Exit;
  end;

  if sv.IsExtendPoint then begin
    Result := RegExtService(sv);
  end else begin
    sv._AddRef;
    FServiceList.AddObject(sv.GetServiceID, Pointer(sv));
    if sv.GetImplementServiceID <> '' then begin
      Result := FServiceList.IndexOf(sv.GetImplementServiceID);
      if Result > -1 then
        IServiceInfo(Pointer(FServiceList.Objects[Result])).AddExtendPointImpService(sv);
    end;
    Result := ERROR_SUCCESS;
  end;
end;

function TServiceManager.ServiceIsActive(const serviceID: MyString): Boolean;
var
  idx: Integer;
  sv: IServiceInfo;
begin
  Result := False;
  //idx := FServiceList.IndexOf(serviceID);
  idx := GetServiceIdx(serviceID);
  if idx = -1 then
    Exit;
  sv := IServiceInfo(Pointer(FServiceList.Objects[idx]));
  Result := sv.IsActive;
end;

function TServiceManager.StartService(const serviceID: MyString): Boolean;
var
  idx: Integer;
  sv: IServiceInfo;
  pv: IPluginInfo;
begin
   idx := GetServiceIdx(serviceID);
   if idx > -1 then begin
     sv := IServiceInfo(Pointer(FServiceList.Objects[idx]));
     if not sv.IsActive then begin
       sv.SetActive(True);
       if ServiceIsActive(PLUGIN_MANAGER_ID) then
         with GetService(PLUGIN_MANAGER_ID) as IPluginManager do begin
           for idx:=0 to GetPluginsCount-1 do begin
             pv := GetPluginInfoByIndex(idx);
             pv.GetPluginLoader.DLLServiceStart(serviceID);
           end;
         end;
     end;

     Result := True;
   end else
     Result := False;
end;

function TServiceManager.StopService(const serviceID: MyString): Boolean;
var
  idx: Integer;
  sv: IServiceInfo;
  pv: IPluginInfo;
begin
   idx := GetServiceIdx(serviceID);
   if idx > -1 then begin
     sv := IServiceInfo(Pointer(FServiceList.Objects[idx]));
     if sv.IsActive then begin
       if ServiceIsActive(PLUGIN_MANAGER_ID) then
         with GetService(PLUGIN_MANAGER_ID) as IPluginManager do begin
           for idx:=0 to GetPluginsCount-1 do begin  //еĲDLLͨĳServiceҪֹͣģʹ˸ServiceĶڵDLLServiceStopнͷŴ蹲ͬصĹ
             pv := GetPluginInfoByIndex(idx);
             pv.GetPluginLoader.DLLServiceStop(serviceID);
           end;
           sv.SetActive(False);
         end;
     end;

     Result := True;
   end else
     Result := False;
end;

function TServiceManager.UnRegService(const serviceID: MyString): Integer;
var
  idx, idx2: Integer;
  sv, svTem: IServiceInfo;
begin
  idx := FServiceList.IndexOf(serviceID);
  if idx = -1 then begin
    Result := ERROR_SERVICE_DONT_NOT_EXIST;
    Exit;
  end;

  StopService(serviceID);
  sv := IServiceInfo(Pointer(FServiceList.Objects[idx]));
  if sv.GetImplementServiceID <> '' then begin
    idx2 := FServiceList.IndexOf(sv.GetImplementServiceID);
    if idx2>-1 then begin
      svTem := IServiceInfo(Pointer(FServiceList.Objects[idx2]));
      svTem.RemoveExtendPointImpService(serviceID);
    end;
  end;
  FServiceList.Delete(idx);
  sv._Release;
  Result := ERROR_SUCCESS;
end;

{ TPluginManager }

{
******************************** TPluginManager ********************************
}
constructor TPluginManager.Create;
begin
  inherited;
  FPluginList := THashedStringList.Create;
end;

destructor TPluginManager.Destroy;
var
  i: Integer;
begin
  for i:=FPluginList.Count-1 downto 0 do
    UnLoadPluginByIndex(i);
  FPluginList.Free;
  inherited;
end;

function TPluginManager.CfgLoadPluginByPluginID(const pluginID: MyString):
    Integer;
var
  idx: Integer;
  sInfo: IServiceInfo;
  pInfo: IPluginInfo;
  lid: MyString;
begin
  //ȼpluginǷѼأм
  idx := FPluginList.IndexOf(pluginID);
  if idx > -1 then begin
    Result := ERROR_SUCCESS;
    Exit;
  end;

  if not GServiceManagerObj.ServiceIsActive(CONFIG_ID) then begin
    Result := ERROR_SERVICE_NOT_ACTIVE;
    Exit;
  end;

  with GServiceManagerObj.GetService(CONFIG_ID) as IConfig do
    if ExistPlugin(pluginID) then
    begin
      if not PluginIsDisable(pluginID) then
      begin
        if not GServiceManagerObj.ServiceIsActive(PLUGIN_INFO_ID) then begin
          Result := ERROR_SERVICE_NOT_ACTIVE;
          Exit;
        end;

        pInfo := GServiceManagerObj.GetService(PLUGIN_INFO_ID) as IPluginInfo;
        lid := GetPluginLoaderID(pluginID);
        if (lid<>'') and GServiceManagerObj.ServiceIsActive(lid) then
          pInfo.SetPluginLoader(GServiceManagerObj.GetService(lid) as IPluginLoader);
        Result := pInfo.GetPluginLoader.LoadPlugin(PluginDLL(pluginID));
        if Result <> ERROR_SUCCESS then
        begin
          pInfo := nil;
          Exit;
        end;

        Result := pInfo.GetPluginLoader.DLLGetPluginInfo(pInfo);
        if Result <> ERROR_SUCCESS then
        begin
          pInfo := nil;
          Exit;
        end;

        //¼PluginManagerHashбУԲidΪkey
        pInfo.SetIsLoadedThroughConfig(True);
        pInfo._AddRef;
        FPluginList.AddObject(pInfo.GetPluginID, Pointer(pInfo));
        //pInfoеÿֻעļȷõķ񵽷÷ģʽ贴
        for idx := pInfo.GetServiceCount - 1 downto 0 do
        begin
          sInfo := pInfo.GetServiceInfo(idx);
          sInfo.SetSingleton(ServiceIsSingleton(sInfo.GetServiceID)); //ļָΪ׼DLLе
          if sInfo.IsExtendPoint then begin
            if not ExistExtPoint(sInfo.GetServiceID) or ExtPointIsDisable(sInfo.GetServiceID) then
              Continue
          end else if not ExistService(sInfo.GetServiceID) or ServiceIsDisable(sInfo.GetServiceID) then
            Continue
          else if (sInfo.GetImplementServiceID<>'') and not GServiceManagerObj.ExistService(sInfo.GetImplementServiceID) then
            Continue;

          GServiceManagerObj.RegService(sinfo);
          sInfo.SetReadOnly;
        end;
        //ò
        SetPluginActiveByPluginID(pInfo.GetPluginID);
      end else
        Result := ERROR_PLUGIN_DISABLED;
    end else
      Result := ERROR_PLUGIN_CONFIG_DOES_NOT_EXIST;
end;

function TPluginManager.CfgLoadPluginByServiceID(const serviceID: MyString):
    Integer;
begin
  if not GServiceManagerObj.ExistService(CONFIG_ID) then begin
    Result := ERROR_SERVICE_DONT_NOT_EXIST;
    Exit;
  end;
  //ֻڷ  񲻱òŷڲID
  with GServiceManagerObj.GetService(CONFIG_ID) as IConfig do
    if ExistService(serviceID) then begin
      if not ServiceIsDisable(serviceID) then begin
        Result := CfgLoadPluginByPluginID(PluginIDFromSid(serviceID));
      end else
        Result := ERROR_SERVICE_DISABLED;
    end else
      Result := ERROR_SERVICE_DOES_NOT_EXIST;
end;

function TPluginManager.CfgReLoadPlugins: Integer;
var
  idx: Integer;
  cfg: IConfig;
  plg: IPluginInfo;
  temS: MyString;
begin
  if not GServiceManagerObj.ServiceIsActive(CONFIG_ID) then begin
    Result := ERROR_SERVICE_DONT_NOT_EXIST;
    Exit;
  end;

  cfg := GServiceManagerObj.GetService(CONFIG_ID) as IConfig;
  //ж뵫µļûеĲ
  for idx := FPluginList.Count-1 downto 0 do begin
    plg := IPluginInfo(Pointer(FPluginList.Objects[idx]));
    if plg.IsLoadedThroughConfig and (not cfg.ExistPlugin(plg.GetPluginID)) then
      UnLoadPluginByIndex(idx);
  end;

  //ļжûеĲ
  for idx := 0 to cfg.GetPluginCount-1 do begin
    temS := cfg.PluginIDFromIdx(idx);
    if FPluginList.IndexOf(temS) = -1 then
      if cfg.GetPluginLoadState(temS) = 'always' then
        CfgLoadPluginByPluginID(temS);
  end;

  Result := ERROR_SUCCESS;
end;

function TPluginManager.GetPluginInfoByIndex(idx: Integer): IPluginInfo;
begin
  Result := nil;
  if (idx<0) or (idx>=FPluginList.Count) then
    Exit;
  Result := IPluginInfo(Pointer(FPluginList.Objects[idx]));
end;

function TPluginManager.GetPluginInfoByPluginID(const pluginID: MyString):
    IPluginInfo;
begin
  Result := GetPluginInfoByIndex(FPluginList.IndexOf(pluginID));
end;

function TPluginManager.GetPluginsCount: Integer;
begin
  Result := FPluginList.Count;
end;

function TPluginManager.GetSelfObject: TObject;
begin
  Result := Self;
end;

function TPluginManager.LoadPluginDirect(const pluginFile: MyString; const
    useLoader: MyString=''): Integer;
var
  idx, count: Integer;
  sInfo: IServiceInfo;
  pInfo: IPluginInfo;
begin
  if AnsiLeftStr(AnsiString(pluginFile), Length(MEMORY_FILE)) <> MEMORY_FILE then
    if not FileExists(pluginFile) then
    begin
      Result := ERROR_FILE_NOT_FOUND;
      Exit;
    end;

  if not GServiceManagerObj.ServiceIsActive(PLUGIN_INFO_ID) then begin
    Result := ERROR_SERVICE_NOT_ACTIVE;
    Exit;
  end;

  pInfo := GServiceManagerObj.GetService(PLUGIN_INFO_ID) as IPluginInfo;
  if (useLoader<>'') and GServiceManagerObj.ServiceIsActive(useLoader) then
    pInfo.SetPluginLoader(GServiceManagerObj.GetService(useLoader) as IPluginLoader);
  Result := pInfo.GetPluginLoader.LoadPlugin(pluginFile);
  if Result <> ERROR_SUCCESS then
  begin
    pInfo := nil;
    Exit;
  end;

  Result := pInfo.GetPluginLoader.DLLGetPluginInfo(pInfo);
  if Result <> ERROR_SUCCESS then
  begin
    pInfo := nil;
    Exit;
  end;

  //ȼpluginǷѼأм
  idx := FPluginList.IndexOf(pInfo.GetPluginID);
  if idx > -1 then begin
    pInfo := nil;
    Result := ERROR_SUCCESS;
    Exit;
  end;

  //¼PluginManagerHashбУԲidΪkey
  pInfo._AddRef;
  pInfo.SetReadOnly;
  FPluginList.AddObject(pInfo.GetPluginID, Pointer(pInfo));
  //for idx := pInfo.GetServiceCount - 1 downto 0 do
  count:=pInfo.GetServiceCount-1;
  for idx := 0 to count do
  begin
    sInfo := pInfo.GetServiceInfo(idx);
    if (sInfo.GetImplementServiceID<>'') and not GServiceManagerObj.ExistService(sInfo.GetImplementServiceID) then
      Continue;
    GServiceManagerObj.RegService(sinfo);
    sInfo.SetReadOnly;
  end;
  //ò
  SetPluginActiveByPluginID(pInfo.GetPluginID);
end;

function TPluginManager.SetPluginActiveByIndex(idx: Integer): Integer;
var
  i: Integer;
  p: IPluginInfo;
begin
  if (idx<0) or (idx>=FPluginList.Count) then begin
    Result := ERROR_OUT_BOUND;
    Exit;
  end;
  //DLLвʼ
  p := IPluginInfo(Pointer(FPluginList.Objects[idx]));
  p.GetPluginLoader.DLLInitializePlugin(GServiceManagerObj);
  //ѲзΪ״̬ÿʱDLLзʼ
  for i:=0 to p.GetServiceCount-1 do
    GServiceManagerObj.StartService(p.GetServiceInfo(i).GetServiceID);
  //Ϊ״̬
  p.SetActive(True);
  Result := ERROR_SUCCESS;
end;

function TPluginManager.SetPluginActiveByPluginID(const pluginID: MyString):
    Integer;
begin
  Result := FPluginList.IndexOf(pluginID);
  if Result>-1 then
    Result := SetPluginActiveByIndex(Result)
  else
    Result := ERROR_PLUGIN_DONT_NOT_EXIST;
end;

function TPluginManager.SetPluginDeActiveByIndex(idx: Integer): Integer;
var
  i: Integer;
  p: IPluginInfo;
begin
  if (idx<0) or (idx>=FPluginList.Count) then begin
    Result := ERROR_OUT_BOUND;
    Exit;
  end;

  p := IPluginInfo(Pointer(FPluginList.Objects[idx]));
  //ѲзΪֹͣ״̬ÿֹͣʱDLLзֹ֪ͣͨ
  for i:=0 to p.GetServiceCount-1 do
    GServiceManagerObj.StopService(p.GetServiceInfo(i).GetServiceID);
  //DLLеDLLUninitializePlugin
  p.GetPluginLoader.DLLUninitializePlugin(GServiceManagerObj);
  //ΪǼ״̬
  p.SetActive(False);
  Result := ERROR_SUCCESS;
end;

function TPluginManager.SetPluginDeActiveByPluginID(const pluginID: MyString):
    Integer;
begin
  Result := FPluginList.IndexOf(pluginID);
  if Result>-1 then
    Result := SetPluginDeActiveByIndex(Result)
  else
    Result := ERROR_PLUGIN_DONT_NOT_EXIST;
end;

function TPluginManager.UnLoadPluginByIndex(idx: Integer): Integer;
var
  i: Integer;
  p: IPluginInfo;
begin
  if (idx<0) or (idx>=FPluginList.Count) then begin
    Result := ERROR_OUT_BOUND;
    Exit;
  end;

  Result := SetPluginDeActiveByIndex(idx);
  if Result = ERROR_SUCCESS then begin
    p := IPluginInfo(Pointer(FPluginList.Objects[idx]));
    //жزDLLаз
    for i:=p.GetServiceCount-1 downto 0 do
      GServiceManagerObj.UnRegService(p.GetServiceInfo(i).GetServiceID);
    //DLLвDLLUninitializePlugin
    //p.GetPluginLoader.DLLUninitializePlugin(GServiceManagerObj);
    FPluginList.Delete(idx);
    p._Release;
    Result := ERROR_SUCCESS;
  end;
end;

function TPluginManager.UnLoadPluginByPluginID(const pluginID: MyString): Integer;
begin
  Result := FPluginList.IndexOf(pluginID);
  if Result>-1 then
    Result := UnLoadPluginByIndex(Result)
  else
    Result := ERROR_PLUGIN_DONT_NOT_EXIST;
end;

function TPluginManager.UpdatePluginDirect(const pluginFile: MyString; const
    useLoader: MyString=''): Integer;
var
  idx: Integer;
  temS, pid: MyString;
  pInfo: IPluginInfo;
  reLoad: Boolean;
begin
  if not FileExists(pluginFile) then
  begin
    Result := ERROR_FILE_NOT_FOUND;
    Exit;
  end;

  if not GServiceManagerObj.ServiceIsActive(CONFIG_ID) then begin
    Result := ERROR_SERVICE_NOT_ACTIVE;
    Exit;
  end;

  //ȻȡϢ
  if not GServiceManagerObj.ServiceIsActive(PLUGIN_INFO_ID) then begin
    Result := ERROR_SERVICE_NOT_ACTIVE;
    Exit;
  end;

  pInfo := GServiceManagerObj.GetService(PLUGIN_INFO_ID) as IPluginInfo;
  Result := pInfo.GetPluginLoader.LoadPlugin(pluginFile);
  if Result <> ERROR_SUCCESS then
  begin
    pInfo := nil;
    Exit;
  end;

  Result := pInfo.GetPluginLoader.DLLGetPluginInfo(pInfo);
  if Result <> ERROR_SUCCESS then
  begin
    pInfo := nil;
    Exit;
  end;

  //ȼpluginǷѼ
  reLoad := False;
  pid := pInfo.GetPluginID;
  idx := FPluginList.IndexOf(pid);
  if idx > -1 then begin
    pInfo := IPluginInfo(Pointer(FPluginList.Objects[idx]));
    temS := pInfo.GetDllName;
    //жͬID
    Result := UnLoadPluginByPluginID(pid);
    if Result <> ERROR_SUCCESS then
      Exit;
    reLoad := True;
  end else
  with GServiceManagerObj.GetService(CONFIG_ID) as IConfig do
    if ExistPlugin(pid) then
      temS := PluginDLL(pid)
    else begin
      Result := ERROR_FILE_NOT_FOUND;
      Exit;
    end;

  if FileExists(temS) then begin
    //ǲ
    DeleteFile(temS);
    MoveFileA(PAnsiChar(AnsiString(pluginFile)), PAnsiChar(AnsiString(temS)));
    if reLoad then
      with GServiceManagerObj.GetService(CONFIG_ID) as IConfig do
        if ExistPlugin(pid) then
          CfgLoadPluginByPluginID(pid)
        else
          LoadPluginDirect(temS);
  end;
end;

{ TPluginLoader }

{
******************************** TPluginLoader *********************************
}
constructor TPluginLoader.Create;
begin
  inherited;
  FDllHandle := 0;
end;

destructor TPluginLoader.Destroy;
begin
  FreeLibrary(FDllHandle);
  inherited;
end;

function TPluginLoader.DLLGetObject(const serviceID: MyString): IInterface;
type
  TDLLGetObject = function(const serviceID: PAnsiChar): IInterface; stdcall;
  TDLLGetObjectForC = function(const serviceID: PAnsiChar): Pointer; stdcall;
var
  DLLGetObject: TDLLGetObject;
{$IFDEF _USE_FOR_CPP}
  //DLLGetObjectForC: TDLLGetObjectForC;
  DLLGetObjectForC: Pointer;
{$ENDIF}
begin
  Result := nil;
  if FDllHandle = 0 then
    Exit;

  DLLGetObject := GetProcAddress(FDllHandle, 'DLLGetObject');
  {$IFDEF _USE_FOR_CPP}
  DLLGetObjectForC := GetProcAddress(FDllHandle, 'GetCppObject');
  {$ENDIF}
  if Assigned(DLLGetObject) then
    Result := DLLGetObject(PAnsiChar(AnsiString(serviceID)))
  {$IFDEF _USE_FOR_CPP}
  else if Assigned(DLLGetObjectForC) then begin
    Result := IInterface(TDLLGetObjectForC(DLLGetObjectForC)(PAnsiChar(AnsiString(serviceID))));
    Result._AddRef;
  end;
  {$ENDIF}
end;

function TPluginLoader.DLLGetPluginInfo(const im: IPluginInfo): Integer;
type
  TDLLGetPluginInfo = procedure(const im: IPluginInfo); stdcall;
{$IFDEF _USE_FOR_CPP}
  TDLLGetPluginInfoForC = procedure(const im: IPluginInfoForC); stdcall;
{$ENDIF}
var
  DLLGetPluginInfo: TDLLGetPluginInfo;
{$IFDEF _USE_FOR_CPP}
  DLLGetPluginInfoForC: TDLLGetPluginInfoForC;
{$ENDIF}
begin
  if not Assigned(im) then
  begin
    Result := ERROR_INTERFACE_IS_NULL;
    Exit;
  end;

  if FDllHandle = 0 then begin
    Result := ERROR_NOT_LOAD_PLUGIN_DLL;
    Exit;
  end;

  DLLGetPluginInfo := GetProcAddress(FDllHandle, 'DLLGetPluginInfo');
{$IFDEF _USE_FOR_CPP}
  DLLGetPluginInfoForC := GetProcAddress(FDllHandle, 'GetPluginInfo');
{$ENDIF}

  if Assigned(DLLGetPluginInfo) then
    DLLGetPluginInfo(TPluginInfo(im.GetSelfObject))
{$IFDEF _USE_FOR_CPP}
  else if Assigned(DLLGetPluginInfoForC) then
    DLLGetPluginInfoForC(TPluginInfo(im.GetSelfObject))
{$ENDIF}
  else begin
    Result := ERROR_NOT_PLUGIN_DLL;
    Exit;
  end;

  if im.GetPluginID = '' then
    Result := ERROR_SERVICE_DONT_NOT_EXIST
  else
    Result := ERROR_SUCCESS;
end;

procedure TPluginLoader.DLLInitializePlugin(const IServiceMgr: IServiceManager);
type
  TDLLInitializePlugin = procedure(const IServiceMgr: IServiceManager); stdcall;
{$IFDEF _USE_FOR_CPP}
  TDLLInitializePluginForC = procedure(const IServiceMgr: IServiceManagerForC); stdcall;
{$ENDIF}
var
  DLLInitializePlugin: TDLLInitializePlugin;
{$IFDEF _USE_FOR_CPP}
  DLLInitializePluginForC: TDLLInitializePluginForC;
{$ENDIF}
begin
  if FDllHandle = 0 then begin
    Exit;
  end;

  DLLInitializePlugin := GetProcAddress(FDllHandle, 'DLLInitializePlugin');
{$IFDEF _USE_FOR_CPP}
  DLLInitializePluginForC := GetProcAddress(FDllHandle, 'InitializePlugin');
{$ENDIF}
  if Assigned(DLLInitializePlugin) then
    //DLLInitializePlugin(IServiceMgr);
    DLLInitializePlugin(TServiceManager(IServiceMgr.GetSelfObject))
{$IFDEF _USE_FOR_CPP}
  else if Assigned(DLLInitializePluginForC) then
    DLLInitializePluginForC(TServiceManager(IServiceMgr.GetSelfObject));
{$ENDIF}
end;

procedure TPluginLoader.DLLServiceStart(const serviceID: MyString);
type
  TDLLServiceStart = procedure(const serviceID: PAnsiChar); stdcall;
{$IFDEF _USE_FOR_CPP}
  TDLLServiceStartForC = procedure(const serviceID: PAnsiChar); stdcall;
{$ENDIF}
var
  DLLServiceStart: TDLLServiceStart;
{$IFDEF _USE_FOR_CPP}
  DLLServiceStartForC: TDLLServiceStartForC;
{$ENDIF}
begin
  if FDllHandle = 0 then begin
    Exit;
  end;

  DLLServiceStart := GetProcAddress(FDllHandle, 'DLLServiceStart');
{$IFDEF _USE_FOR_CPP}
  DLLServiceStartForC := GetProcAddress(FDllHandle, 'ServiceStart');
{$ENDIF}
  if Assigned(DLLServiceStart) then
    DLLServiceStart(PAnsiChar(AnsiString(serviceID)))
{$IFDEF _USE_FOR_CPP}
  else if Assigned(DLLServiceStartForC) then
    DLLServiceStartForC(PAnsiChar(AnsiString(serviceID)));
{$ENDIF}
end;

procedure TPluginLoader.DLLServiceStop(const serviceID: MyString);
type
  TDLLServiceStop = procedure(const serviceID: PAnsiChar); stdcall;
{$IFDEF _USE_FOR_CPP}
  TDLLServiceStopForC = procedure(const serviceID: PAnsiChar); stdcall;
{$ENDIF}
var
  DLLServiceStop: TDLLServiceStop;
{$IFDEF _USE_FOR_CPP}
  DLLServiceStopForC: TDLLServiceStopForC;
{$ENDIF}
begin
  if FDllHandle = 0 then begin
    Exit;
  end;

  DLLServiceStop := GetProcAddress(FDllHandle, 'DLLServiceStop');
{$IFDEF _USE_FOR_CPP}
  DLLServiceStopForC := GetProcAddress(FDllHandle, 'ServiceStop');
{$ENDIF}
  if Assigned(DLLServiceStop) then
    DLLServiceStop(PAnsiChar(AnsiString(serviceID)))
{$IFDEF _USE_FOR_CPP}
  else if Assigned(DLLServiceStopForC) then
    DLLServiceStopForC(PAnsiChar(AnsiString(serviceID)));
{$ENDIF}
end;

procedure TPluginLoader.DLLUninitializePlugin(const IServiceMgr:
    IServiceManager);
type
  TDLLUninitializePlugin = procedure(const IServiceMgr: IServiceManager); stdcall;
{$IFDEF _USE_FOR_CPP}
  TDLLUninitializePluginForC = procedure(const IServiceMgr: IServiceManagerForC); stdcall;
{$ENDIF}
var
  DLLUninitializePlugin: TDLLUninitializePlugin;
{$IFDEF _USE_FOR_CPP}
  DLLUninitializePluginForC: TDLLUninitializePluginForC;
{$ENDIF}
begin
  if FDllHandle = 0 then begin
    Exit;
  end;

  DLLUninitializePlugin := GetProcAddress(FDllHandle, 'DLLUninitializePlugin');
{$IFDEF _USE_FOR_CPP}
  DLLUninitializePluginForC := GetProcAddress(FDllHandle, 'UninitializePlugin');
{$ENDIF}
  if Assigned(DLLUninitializePlugin) then
    //DLLUninitializePlugin(IServiceMgr);
    DLLUninitializePlugin(TServiceManager(IServiceMgr.GetSelfObject))
{$IFDEF _USE_FOR_CPP}
  else if Assigned(DLLUninitializePluginForC) then
    DLLUninitializePluginForC(TServiceManager(IServiceMgr.GetSelfObject));
{$ENDIF}
end;

function TPluginLoader.GetLoadedPluginFile: MyString;
begin
  Result := FDLLFile;
end;

function TPluginLoader.GetSelfObject: TObject;
begin
  Result := Self;
end;

function TPluginLoader.LoadPlugin(const pluginFile: MyString): Integer;
begin
  if not FileExists(pluginFile) then
  begin
    Result := ERROR_FILE_NOT_FOUND;
    Exit;
  end;

  if LowerCase(ExtractFileExt(pluginFile)) = '.bpl' then
    FDllHandle := LoadPackage(pluginFile)
  else
    FDllHandle := LoadLibraryA(PAnsiChar(AnsiString(pluginFile)));
  if FDllHandle = 0 then
  begin
    Result := ERROR_NOT_PLUGIN_DLL;
    Exit;
  end;
  FDLLFile := pluginFile;

  Result := ERROR_SUCCESS;
end;

//  procedure DoUnloadPackage(Module: HModule);
//  var
//    i: Integer;
//    M: TMemoryBasicInformation;
//  begin
//    for i := Application.ComponentCount - 1 downto 0 do
//    begin
//      VirtualQuery(GetClass(Application.Components[i].ClassName), M, Sizeof(M));
//      if (Module = 0) or (HMODULE(M.AllocationBase) = Module) then
//        Application.Components[i].Free;
//    end;
//    UnregisterModuleClasses(Module);
//    UnloadPackage(Module);
//  end;

function TPluginLoader.UnLoadPlugin: Integer;
begin
   Result := ERROR_SUCCESS;
  if LowerCase(ExtractFileExt(PMyChar(MyString(FDLLFile)))) = '.bpl' then begin
    //UnregisterModuleClasses(FDllHandle);
    UnloadPackage(FDllHandle);
  end;// else
  if not FreeLibrary(FDllHandle) then
    Result := ERROR_UNLOAD_PLUGIN_FAIL;
  FDllHandle := 0;
  FDLLFile := '';
end;


{ TWisdomFramework }

{
******************************* TWisdomFramework *******************************
}
class procedure TWisdomFramework.FinalFramwork;
begin
  GServiceManager := nil;
  GServiceManagerObj.Free;
end;

class procedure TWisdomFramework.InitFramwork;
begin
  if not Assigned(GServiceManagerObj) then begin
    GServiceManagerObj := TServiceManager.Create;
    GServiceManager := GServiceManagerObj;
  end;
end;

class procedure TWisdomFramework.Run;
begin
  if not Assigned(GServiceManager) then
    raise Exception.Create('δгʼInitFramworkʼܡ');

  if GServiceManager.ServiceIsActive(PLUGIN_MANAGER_ID) then
    with GServiceManager.GetService(PLUGIN_MANAGER_ID) as IPluginManager do
      CfgReLoadPlugins;
end;

class procedure TWisdomFramework.Stop;
var
  i: Integer;
begin
  if Assigned(GServiceManager) and GServiceManager.ServiceIsActive(PLUGIN_MANAGER_ID) then
    with GServiceManager.GetService(PLUGIN_MANAGER_ID) as IPluginManager do begin
      for i:=GetPluginsCount-1 downto 0 do
        UnLoadPluginByIndex(i);
    end;
end;

initialization
  TWisdomFramework.InitFramwork;

finalization
  if Assigned(GServiceManager) then begin
    TWisdomFramework.Stop;
    TWisdomFramework.FinalFramwork;
  end;



end.

